> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Transactions for a Client Wallet

This call returns all the transactions targeting or emitted from a Client Wallet, for example:

* Fees payouts made from the Fees Wallet (`FEES_CCY`)
* Repudiations and settlements made from or to the Repudiation Wallet (`CREDIT_CCY`)
* Conversions between Client Wallets

### Path parameters

<ParamField path="FundsType" type="string" required>
  **Allowed values:** `FEES`, `CREDIT`

  The type of funds in the Client Wallet:

  * `FEES` – Fees Wallet, for fees collected by the platform, specific to the Client Wallet object.
  * `CREDIT` – Repudiation Wallet, for funds for the platform's dispute management, specific to the Client Wallet object.

  **Note:** The Fees Wallet and Repudiation Wallet are created automatically by Mangopay for each currency.
</ParamField>

<ParamField path="Currency" type="string" required>
  **Allowed values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

  The currency of the wallet.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200">
    <ResponseField name="Array (Transactions)" type="array">
      The list of transactions created by the platform.

      <Expandable title="properties">
        <ResponseField name="Object (transaction)" type="object">
          The transaction created by the platform.

          <Expandable title="properties">
            <ResponseField name="Id" type="string">
              Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

              The unique identifier of the object.
            </ResponseField>

            <ResponseField name="Tag" type="string">
              Max. length: 255 characters

              Custom data that you can add to this object.\
              For transactions (pay-in, transfer, payout), you can use this parameter to identify corresponding information regarding the user, transaction, or payment methods on your platform.
            </ResponseField>

            <ResponseField name="CreationDate" type="Unix timestamp">
              The date and time at which the object was created.
            </ResponseField>

            <ResponseField name="AuthorId" type="string">
              The unique identifier of the user at the source of the transaction.
            </ResponseField>

            <ResponseField name="CreditedUserId" type="string">
              **Default value:** The unique identifier of the owner of the credited wallet.

              The unique identifier of the user whose wallet is credited.
            </ResponseField>

            <ResponseField name="DebitedFunds" type="object">
              Information about the debited funds.

              <Expandable title="properties">
                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the debited funds (the sell currency).
                </ResponseField>

                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).

                  During a conversion, (`DebitedFunds.Amount` - `Fees`) \* `MarketRate` = `CreditedFunds.Amount`. 
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="CreditedFunds" type="object">
              Information about the credited funds (`CreditedFunds` = `DebitedFunds` - `Fees`).

              <Expandable title="properties">
                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the credited funds.
                </ResponseField>

                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="Fees" type="object">
              Information about the fees taken by the platform for this transaction (and hence transferred to the Fees Wallet).

              <Expandable title="properties">
                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the fees.
                </ResponseField>

                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="Status" type="string">
              **Returned values:** `CREATED`, `SUCCEEDED`, `FAILED`

              The status of the transaction.
            </ResponseField>

            <ResponseField name="ResultCode" type="string">
              The code indicating the result of the operation. This information is mostly used to <a href="/errors/codes">handle errors</a> or for filtering purposes.
            </ResponseField>

            <ResponseField name="ResultMessage" type="string">
              The explanation of the result code.
            </ResponseField>

            <ResponseField name="ExecutionDate" type="Unix timestamp">
              The date and time at which the status changed to `SUCCEEDED`, indicating that the transaction occurred. The statuses `CREATED` and `FAILED` return an `ExecutionDate` of `null`.
            </ResponseField>

            <ResponseField name="Type" type="string">
              The type of transaction.
            </ResponseField>

            <ResponseField name="Nature" type="string">
              **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

              The nature of the transaction, providing more information about the context in which the transaction occurred:

              * `REGULAR` – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow.
              * `REPUDIATION` – Automatic withdrawal of funds from the platform’s repudiation wallet as part of the dispute process (when the user has requested a chargeback).
              * `REFUND` – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay).
              * `SETTLEMENT` – Transfer made to the repudiation wallet by the platform to settle a lost dispute.
            </ResponseField>

            <ResponseField name="CreditedWalletId" type="string">
              The unique identifier of the credited wallet.
            </ResponseField>

            <ResponseField name="DebitedWalletId" type="string">
              The unique identifier of the debited wallet.
            </ResponseField>
          </Expandable>
        </ResponseField>
      </Expandable>
    </ResponseField>
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200 theme={null}
  [
      {
          "Id": "po_m_01HY343CF0KFEPKFJ0QZ4HZ2VK",
          "Tag": "Custom data",
          "CreationDate": 1715944403,
          "AuthorId": "ExampleClientId",
          "CreditedUserId": null,
          "DebitedFunds": {
              "Currency": "EUR",
              "Amount": 7836
          },
          "CreditedFunds": {
              "Currency": "EUR",
              "Amount": 7836
          },
          "Fees": {
              "Currency": "EUR",
              "Amount": 0
          },
          "Status": "SUCCEEDED",
          "ResultCode": "000000",
          "ResultMessage": "Success",
          "ExecutionDate": 1715944624,
          "Type": "PAYOUT",
          "Nature": "REGULAR",
          "CreditedWalletId": null,
          "DebitedWalletId": "FEES_EUR",
          "DepositId": null
      },
      {
          "Id": "cvr_01J2BS3XE0JE9F05MM5B6VCT15",
          "Tag": "Custom data",
          "CreationDate": 1720529843,
          "AuthorId": "ExampleClientId",
          "CreditedUserId": "ExampleClientId",
          "DebitedFunds": {
              "Currency": "EUR",
              "Amount": 2617
          },
          "CreditedFunds": {
              "Currency": "USD",
              "Amount": 2830
          },
          "Fees": {
              "Currency": "EUR",
              "Amount": 0
          },
          "Status": "SUCCEEDED",
          "ResultCode": "000000",
          "ResultMessage": "Success",
          "ExecutionDate": 1720529845,
          "Type": "CONVERSION",
          "Nature": "REGULAR",
          "CreditedWalletId": "FEES_USD",
          "DebitedWalletId": "FEES_EUR",
          "DepositId": null
      }
  ]
  ```
</ResponseExample>

<RequestExample>
  <RestNoBody />

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk')
  const mangopay = new mangopayInstance({
      clientId: 'your-client-id',
      clientApiKey: 'your-api-key',
  })

  let myWallet = {
    FundsType: 'FEES',
    Currency: 'EUR',
  }

  const listTransactionsClientWallet = async (fundsType, currency) => {
    return await mangopay.Clients.getClientWalletTransactions(fundsType, currency)
      .then((response) => {
        console.info(response)
        return response
      })
      .catch((err) => {
        console.log(err)
        return false
      })
  }

  listTransactionsClientWallet(myWallet.FundsType, myWallet.Currency)  
  ```

  ```ruby Ruby theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def listClientWalletTransactions(fundsType, currency)
      begin
          response = MangoPay::Client.fetch_wallet_transactions(fundsType, currency)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to fetch wallet transactions: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myClientWallet = {
      FundsType: 'FEES',
      Currency: 'EUR'
  }

  listClientWalletTransactions(myClientWallet[:FundsType], myClientWallet[:Currency])
  ```

  ```java Java   theme={null}
  import com.mangopay.MangoPayApi;
  import com.mangopay.core.Money;
  import com.mangopay.core.Pagination;
  import com.mangopay.core.enumerations.CurrencyIso;
  import com.mangopay.core.enumerations.FundsType;
  import com.mangopay.entities.Wallet;

  public class ListClientWalletTransactions {
      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          List<Transaction> clientTransactions = mangopay.getClientApi().getWalletTransactions(FundsType.CREDIT, CurrencyIso.EUR, new Pagination(1, 100), null, null);

          for (Transaction clientTransaction : clientTransactions) {
              Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
              String prettyJson = prettyPrint.toJson(updateUbo);

              System.out.println(clientTransaction);
          }
      }
  }
  ```

  ```python Python  theme={null}
  from pprint import pprint

  import mangopay

  mangopay.client_id='your-client-id'
  mangopay.apikey='your-api-key'

  from mangopay.api import APIRequest
  handler = APIRequest(sandbox=True)

  from mangopay.resources import ClientWallet, Transaction

  client_wallet = ClientWallet.get(funds_type = 'FEES', currency = 'GBP') 

  transactions = Transaction.all(user_id = mangopay.client_id, wallet_id = client_wallet.id)

  for transaction in transactions:
      pprint(vars(transaction))
  ```
</RequestExample>
